/*  OpenTally: Open-source election vote counting
 *  Copyright © 2021 Lee Yingtong Li (RunasSudo)
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Affero General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Affero General Public License for more details.
 *
 *  You should have received a copy of the GNU Affero General Public License
 *  along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

mod utils;

use opentally::numbers::Rational;
use opentally::stv;

#[test]
fn prsa1_rational() {
	let stv_opts = stv::STVOptions {
		round_tvs: Some(3),
		round_weights: Some(3),
		round_votes: Some(3),
		round_quota: Some(3),
		sum_surplus_transfers: stv::SumSurplusTransfersMode::SingleStep,
		meek_surplus_tolerance: String::new(),
		normalise_ballots: false,
		quota: stv::QuotaType::Droop,
		quota_criterion: stv::QuotaCriterion::GreaterOrEqual,
		quota_mode: stv::QuotaMode::Static,
		ties: vec![],
		surplus: stv::SurplusMethod::EG,
		surplus_order: stv::SurplusOrder::ByOrder,
		transferable_only: true,
		exclusion: stv::ExclusionMethod::ParcelsByOrder,
		meek_nz_exclusion: false,
		early_bulk_elect: false,
		bulk_exclude: false,
		defer_surpluses: false,
		meek_immediate_elect: false,
		constraints_path: None,
		constraint_mode: stv::ConstraintMode::GuardDoom,
		pp_decimals: 2,
	};
	utils::read_validate_election::<Rational>("tests/data/prsa1.csv", "tests/data/prsa1.blt", stv_opts, None, &["exhausted", "lbf"]);
}
